﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Security.Cryptography;

namespace Steganographer {
    public partial class Form1 : Form {
        #region Settings

        private static int _iterations = 2;
        private static int _keySize = 256;

        private static string _hash = "SHA1";

        private static string _salt = "z5tZ0YgJdd2HeWrubci52gOkv3eNFAbX";
        private static string _vector = "xnT3QSKTsAldLnw0T8Jlg5lpGmZ17Y5t";

        #endregion
        public Form1() {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e) {
            OpenFileDialog openDialog = new OpenFileDialog();
            openDialog.Filter = "Image Files (*.png, *.jpg) | *.png; *.jpg";
            // openDialog.InitialDirectory = @"C:\";

            if (openDialog.ShowDialog() == DialogResult.OK) {
                textBox1.Text = openDialog.FileName.ToString();
                pictureBox1.ImageLocation = textBox1.Text;
            }
        }

        private void button2_Click(object sender, EventArgs e) {
            try {
                string encryptedText;
                if (checkBox1.Checked) {
                    encryptedText = Form1.Encrypt(textBox2.Text, textBox3.Text);
                } else {
                    encryptedText = textBox2.Text;
                }
                // textBox4.Text = encryptedText;
                // string decrypted = Form1.Decrypt(encryptedText, textBox3.Text);
                Bitmap img = new Bitmap(textBox1.Text);

                int position;
                for (int i = 0; i < img.Height; i++) {
                    for (int j = 0; j < img.Width; j++) {

                        position = j + i * img.Width;
                        if (position < encryptedText.Length) {
                            Color pixel = img.GetPixel(i, j);
                            // Console.WriteLine("R = [" + i + "][" + j + "] = " + pixel.R);
                            // Console.WriteLine("G = [" + i + "][" + j + "] = " + pixel.G);
                            // Console.WriteLine("G = [" + i + "][" + j + "] = " + pixel.B);
                            char letter = Convert.ToChar(encryptedText.Substring(position, 1));
                            int value = Convert.ToInt32(letter);
                            // Console.WriteLine("Letter : " + letter + " Value : " + value);

                            img.SetPixel(j, i, Color.FromArgb(pixel.R, pixel.G, value));
                        }
                    }
                }

                Color lastpixel = img.GetPixel(img.Width - 1, img.Height - 1);
                int[] weights = { 0, 0, 0 };
                weights[0] = encryptedText.Length % 256;
                weights[1] = (encryptedText.Length / 256) % 256;
                weights[2] = ((encryptedText.Length / 256) / 256) % 256;

                img.SetPixel(img.Width - 1, img.Height - 1, Color.FromArgb(weights[2], weights[1], weights[0]));
                SaveFileDialog saveFile = new SaveFileDialog();
                saveFile.Filter = "Image Files (*.png, *.jpg) | *.png; *.jpg";
                // saveFile.InitialDirectory = @"C:\";

                if (saveFile.ShowDialog() == DialogResult.OK) {
                    textBox1.Text = saveFile.FileName.ToString();
                    pictureBox1.ImageLocation = textBox1.Text;

                    img.Save(textBox1.Text);
                }
            } catch {
                MessageBox.Show("An error occured while processing the image.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void button3_Click(object sender, EventArgs e) {
            try {
                Bitmap img = new Bitmap(textBox1.Text);
                string message = "";

                Color lastpixel = img.GetPixel(img.Width - 1, img.Height - 1);
                int msgLength = (lastpixel.B) + (lastpixel.G * 256) + (lastpixel.R * 256 * 256);

                int position;
                for (int i = 0; i < img.Width; i++) {
                    for (int j = 0; j < img.Height; j++) {
                        position = j + i * img.Width;
                        if (position < msgLength) {
                            Color pixel = img.GetPixel(j, i);

                            int value = pixel.B;
                            char c = Convert.ToChar(value);
                            string letter = System.Text.Encoding.ASCII.GetString(new byte[] { Convert.ToByte(c) });

                            message = message + letter;
                        }
                    }
                }
                // textBox4.Text = message;
                if (checkBox1.Checked) {
                    string decrypted = Form1.Decrypt(message, textBox3.Text);
                    textBox2.Text = decrypted;
                } else {
                    textBox2.Text = message;
                }
            } catch {
                MessageBox.Show("An error occured while processing the image.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        private void label3_Click(object sender, EventArgs e) {
            System.Diagnostics.Process.Start("http://www.blackhost.xyz");
        }

        public static string Encrypt(string value, string password) {
            return Encrypt<AesManaged>(value, password);
        }
        public static string Encrypt<T>(string value, string password)
                where T : SymmetricAlgorithm, new() {
            byte[] vectorBytes = Encoding.ASCII.GetBytes(_vector);
            byte[] saltBytes = Encoding.ASCII.GetBytes(_salt);
            byte[] valueBytes = Encoding.ASCII.GetBytes(value);

            byte[] encrypted;
            using (T cipher = new T()) {
                PasswordDeriveBytes _passwordBytes =
                    new PasswordDeriveBytes(password, saltBytes, _hash, _iterations);
                byte[] keyBytes = _passwordBytes.GetBytes(_keySize / 8);

                cipher.Mode = CipherMode.CBC;

                using (ICryptoTransform encryptor = cipher.CreateEncryptor(keyBytes, vectorBytes)) {
                    using (MemoryStream to = new MemoryStream()) {
                        using (CryptoStream writer = new CryptoStream(to, encryptor, CryptoStreamMode.Write)) {
                            writer.Write(valueBytes, 0, valueBytes.Length);
                            writer.FlushFinalBlock();
                            encrypted = to.ToArray();
                        }
                    }
                }
                cipher.Clear();
            }
            return Convert.ToBase64String(encrypted);
        }

        public static string Decrypt(string value, string password) {
            return Decrypt<AesManaged>(value, password);
        }
        public static string Decrypt<T>(string value, string password) where T : SymmetricAlgorithm, new() {
            byte[] valueBytes = Convert.FromBase64String(value);
            byte[] vectorBytes = Encoding.ASCII.GetBytes(_vector);
            byte[] saltBytes = Encoding.ASCII.GetBytes(_salt);

            byte[] decrypted;
            int decryptedByteCount = 0;

            using (T cipher = new T()) {
                PasswordDeriveBytes _passwordBytes = new PasswordDeriveBytes(password, saltBytes, _hash, _iterations);
                byte[] keyBytes = _passwordBytes.GetBytes(_keySize / 8);

                cipher.Mode = CipherMode.CBC;

                try {
                    using (ICryptoTransform decryptor = cipher.CreateDecryptor(keyBytes, vectorBytes)) {
                        using (MemoryStream from = new MemoryStream(valueBytes)) {
                            using (CryptoStream reader = new CryptoStream(from, decryptor, CryptoStreamMode.Read)) {
                                decrypted = new byte[valueBytes.Length];
                                decryptedByteCount = reader.Read(decrypted, 0, decrypted.Length);
                            }
                        }
                    }
                } catch (Exception ex) {
                    return String.Empty;
                }

                cipher.Clear();
            }
            return Encoding.UTF8.GetString(decrypted, 0, decryptedByteCount);
        }
    }
}